Subject: Re: [Tsvwg] HEADS UP: consensus call on draft-floyd-tsvwg-cc-alt

From: Mark Allman <[email-masked]>
Date: Mon, 05 Mar 2007 09:58:26 -0500

Folks-

About this business of fairness.  We had a little thread with Bob
off-list.  We changed the text in the draft a bit to make it more
generic, change the emphasis and remove some specific examples.  Bob has
indicated to us that the changes work for him.

Basically, instead of using 'fairness' as the measuring stick (whatever
that might mean in whatever context) we have said that an alternate
congestion control scheme should present evidence about how it impacts
standard congestion control.  How that is assessed is not specified.

We replaced the bullets on 'fairness' and on 'spare capacity' in the
draft with the text included below.  We would, of course, be open to
comments on the new text.

The TSVWG-00 document should be coming out in the archives, soon.
However, there was a snafu in the posting process.  You can grab the
current version at:

    http://www.icir.org/mallman/papers/draft-ietf-tsvwg-cc-alt-00.txt

allman

    (1) Impact on Standard TCP, SCTP [RFC2960], and DCCP [RFC4340].
    
        Proposed congestion control mechanisms should be evaluated when
        competing with standard IETF congestion control.  Alternate
        congestion controllers that have a significantly negative impact
        on traffic using standard congestion control may be suspect and
        this aspect should be part of the community's decision making
        with regards to the suitability of the alternate congestion
        control mechanism.

	We note that this bullet is not a requirement for strict
	TCP-friendliness as a prerequisite for an alternate congestion
	control mechanism to advance to Experimental.  As an example,
	HighSpeed TCP is a congestion control mechanism that is
	Experimental, but that is not TCP-friendly in all environments.
	We also note that this guideline does not constrain the
	fairness offered for non-best-effort traffic.

        As an example from an Experimental RFC, fairness with standard
<        TCP is discussed in Sections 4 and 6 of RFC 3649 (High-Speed
        TCP) and using spare capacity is discussed in Sections 6, 11.1,
        and 12 of RFC 3649 (High-Speed TCP).

---

From: Sally Floyd <[email-masked]>
Date: Sun, 25 Mar 2007 18:22:19 -0700

Mitchell -

My apologies for the delay in replying.

> 	My two cents..
>
> 	One cent
> 	---------
> 	Is TCP fair? With two flows that start at the same time, with
> 	at least 1 hop in common, doesn't a lower RTT flow, absorb
> 	a greater amount of bandwidth? Of course it does..
>
> 	Shouldn't TCP allow both, in this example, to achieve a
> 	stasis window where both flows are using approximately
> 	50% of the available bandwidth on this common hop?
>
> 	There are more examples of where TCP isn't fair. However,
> 	should TCP have a priority goal of fairness? If one flow
> 	sees congestion before another and does a MD, where the
> 	other flow keeps doing AI, then this does not violate the
> 	TCP protocol.
>
> 	Maybe I missed it, but should the doc discuss the effects
> 	of tail-drop versus RED on multiple flows?
>
> 	Thus, is it fair to measure different TCP implementations
> 	in a heterogenous environment based on some set of criteria
> 	of fairness?? Shouldn't we EXPECT some level of UNFAIRNESS
> 	in heterogeneous environments (multiple different systems
> 	using diifferent TCP implementations)?
>
> 	Two cent
> 	--------
> 	Maybe I missed it, but should the doc discuss the effects
> 	of tail-drop versus RED on TCP flows? Which one is
> 	"more fair"? Does RED reduce congestion as it reduces
> 	the effective size of the input buffers, which allows
> 	for bursty traffic. Isn't the TCP protocol bursty in
> 	nature due to the fact that no interpacket gap is
> 	MANDATORY or even suggested  between segments on
> 	transmission?

As I said in my earlier email:

>> draft-floyd-tsvwg-cc-alt doesn't attempt to give detailed 
>> *requirements*
>> for fairness, it just discusses fairness (flow-rate fairness) as one 
>> of the
>> issues to be considered in evaluating new congestion control 
>> mechanisms.
>>
>> Detailed metrics on fairness, issues about fairness and packet size, 
>> etc.,
>> are discussed in draft-irtf-tmrg-metrics-07, Metrics for the 
>> Evaluation of
>> Congestion Control Mechanisms.  That draft, and an updated version
>> in progress that has not yet been submitted, are available from
>> "http://www.icir.org/floyd/papers.html".

That seems to me the right document for a discussion of all of the 
intricacies of
fairness as a metric.  That document discusses issues about fairness 
and RTT,
and a number of other issues.

- Sally
http://www.icir.org/floyd/